
/****************************************************

Mini-STM32 SD/MMC WAV Audio Player
yus	- http://projectproto.blogspot.com/
June 2010

*****************************************************/

#include "stm32f10x.h"
#include <string.h>

#include "ministm32_lcd.h"

#include "pff.h"
#include "wave_file.h"
#include "pwm_audio.h"

FATFS Fs;			/* File system object */
DIR Dir;			/* Directory object */
FILINFO Fno;		/* File information */

void delay(void);

int main(void)
{

	pwm_audio_init();

	LCD_Init();

	//LCD_Text(30, 30, "Mini-STM32 WAVE Audio Player", LCD_Yellow, LCD_Red);	

	while(1){
		delay();
		if (pf_mount(&Fs) ) continue;	/* Initialize FS */
		while(1){
			if (pf_opendir(&Dir, "")) break;				// open root directory
			while (!pf_readdir(&Dir, &Fno) && Fno.fname[0]) {
				if( strstr(Fno.fname, ".WAV") ){			// WAV file
					LCD_Clear(LCD_Red);
					LCD_Text(30, 20, "Mini-STM32 WAVE Audio Player", LCD_Yellow, LCD_Red);
					play_wave_file(Fno.fname);
					//delay();
				}

				
			}
		}
		
	}
}

void delay(void)
{
	long i=0x7FFFFF;
	while(--i);
}
